Description

When using the query builder, queries get converted to a table name when updating the query (right-clic on the layer > Update SQL

Layer... ).

It is something I observed in previous 3.x versions as well. 

Here's my recipe to reproduce the issue in the QGIS 3.2.1-Bonn (1edf372fb8)

In the database manager: menu > Database > DB Manager > connect to a database 

(I'm connected to a postgis database)

Once connected, open the SQL Window (F2)

Load the following Query (check `load new layer`, select the `geom` column and then clic load):

`select st_setsrid(st_point(0, 0), 4326) as geom`

Then edit the newly created layer (probably named QueryLayer) in the Layers panel:

right-clic on the layer > Update SQL Layer...

I get the following error:

An error occured when running a query:

relation "select st_setsrid(st_point(0, 0), 4326) as geom" does not exist

LINE 1: SELECT * FROM "select st_setsrid(st_point(0, 0), 4326) as ge...

^

Query:

SELECT * FROM "select st_setsrid(st_point(0, 0), 4326) as geom

"

The whole query was converted to a table name. Same thing with CTEs (WITH).

Related issues:

Duplicates QGIS Application - Bug report # 18244: DB Manager: "Update SQL lay... Closed 2018-02-27

Duplicated by QGIS Application - Bug report # 19926: Editing the expression f... Closed 2018-09-24

Associated revisions

Revision a8bf1b8f - 2018-09-20 12:43 PM - Alessandro Pasotti 

[dbmanager] Fix Update SQL Layer converts query to table name

Fixes #19843
History

#1 - 2018-09-14 06:31 PM - Giovanni Manghi

- Status changed from Open to Feedback

Does it work as expected on 2.18?

#2 - 2018-09-18 06:16 PM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#3 - 2018-09-20 12:46 PM - Alessandro Pasotti

- Status changed from Feedback to In Progress

- Pull Request or Patch supplied changed from No to Yes

PR https://github.com/qgis/QGIS/pull/7966

#4 - 2018-09-20 02:45 PM - Jérôme Guélat

I guess this is the same #18244

Thanks for fixing it!

#5 - 2018-09-20 02:55 PM - Jürgen Fischer

- Duplicates Bug report #18244: DB Manager: "Update SQL layer" error  added

#6 - 2018-09-21 09:55 AM - Anonymous

- Status changed from In Progress to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|a8bf1b8f05ac2d569fd58bdf9951e8a756344a5e.

#7 - 2018-09-21 09:56 AM - Alessandro Pasotti

- Resolution set to fixed/implemented

#8 - 2018-09-24 09:39 AM - Alessandro Pasotti

- Duplicated by Bug report #19926: Editing the expression for a SQL layer corrupts the SQL expression added

#9 - 2018-09-25 02:33 PM - Lars Kellogg-Stedman

Should this be fixed in commit:208571a?  With that version of the code, selecting "Update SQL Layer..." still produces a database error, although a slightly

different one:

near "(": syntax error

And instead of treating the existing query as a table name, it is now trying to surround the entire expression with parentheses:

(select ... from ...)
This appears to be an artifact of how the query expression is stored; looking at the layer source, I see:

dbname='lic.db' table="(select ... from ...)" (geom) sql=

Those parentheses result in the syntax error when trying to execute the expression in the DB manager.

#10 - 2018-09-25 06:27 PM - Giovanni Manghi

Lars Kellogg-Stedman wrote:

Should this be fixed in commit:208571a?  With that version of the code, selecting "Update SQL Layer..." still produces a database error, although a

slightly different one:

this commit is more recent than the one of the fix. Please file a new ticket then.

#11 - 2018-09-26 02:30 PM - Lars Kellogg-Stedman

Sure. I thought this was the same problem (e.g., the fix was not actually a complete fix) and was more appropriate here, but I'm happy to open a new ticket

instead.
